unit FormProgress;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TfrmProgress = class(TForm)
    ProgressBar1: TProgressBar;
    lblLine1: TLabel;
    lblLine2: TLabel;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SetTitle(Title: string);
    procedure SetSubTitle(Title: string);
    procedure SetProgressMin(Value: Integer);
    procedure SetProgressMax(Value: Integer);
    procedure SetProgressPos(Value: Integer);
    procedure ProgressStepIt;
  end;

var
  frmProgress: TfrmProgress;

implementation

{$R *.dfm}

procedure TfrmProgress.SetTitle(Title: string);
begin
  lblLine1.Caption := Title;
end;

procedure TfrmProgress.SetSubTitle(Title: string);
begin
  lblLine2.Caption := Title;
end;

procedure TfrmProgress.SetProgressMin(Value: Integer);
begin
  ProgressBar1.Min := Value;
end;

procedure TfrmProgress.SetProgressMax(Value: Integer);
begin
  ProgressBar1.Max := Value;
end;

procedure TfrmProgress.SetProgressPos(Value: Integer);
begin
  ProgressBar1.Position := Value;
end;

procedure TfrmProgress.ProgressStepIt;
begin
  ProgressBar1.StepIt;
  Repaint;
end;

procedure TfrmProgress.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := False;
end;

end.
