unit SortFunctions;

interface

uses FormMain, Gta3Archive, SysUtils;

const
  SORT_ASCENDING  = 0;
  SORT_DESCENDING = 1;

function SortByName(Item1, Item2: Pointer): integer;
function SortByType(Item1, Item2: Pointer): integer;
function SortBySize(Item1, Item2: Pointer): integer;
function SortByIndex(Item1, Item2: Pointer): integer;

implementation

function CompareInt(Int1, Int2: Integer):integer;
begin
  if Int1 > Int2 then
    result := 1
  else
    if Int1 = Int2 then
      result := 0
    else
      result := -1;
end;

function SortByName(Item1, Item2: Pointer): integer;
begin
  if Sort.Direction = SORT_ASCENDING then
  begin
    Result := CompareText(TDirEntry(Item1^).Name, TDirEntry(Item2^).Name);
  end
  else
  begin
    Result := -CompareText(TDirEntry(Item1^).Name, TDirEntry(Item2^).Name);
  end;
end;

function SortByIndex(Item1, Item2: Pointer): integer;
begin
  Result := CompareInt(TDirEntry(Item1^).Index, TDirEntry(Item2^).Index);
end;

function SortByType(Item1, Item2: Pointer): integer;
begin
  if Sort.Direction = SORT_ASCENDING then
  begin
    Result := CompareText(frmMain.GetTypeName(TDirEntry(Item1^).Name), frmMain.GetTypeName(TDirEntry(Item2^).Name));
    if Result = 0 then
      Result := SortByName(Item1, Item2);     
  end
  else
  begin
    Result := -CompareText(frmMain.GetTypeName(TDirEntry(Item1^).Name), frmMain.GetTypeName(TDirEntry(Item2^).Name));
    if Result = 0 then
      Result := -SortByName(Item1, Item2);
  end;
end;

function SortBySize(Item1, Item2: Pointer): integer;
begin
  if Sort.Direction = SORT_ASCENDING then
  begin
    Result := CompareInt(TDirEntry(Item1^).BlockCount, TDirEntry(Item2^).BlockCount);
    if Result = 0 then
      Result := SortByName(Item1, Item2);
  end
  else
  begin
    Result := -CompareInt(TDirEntry(Item1^).BlockCount, TDirEntry(Item2^).BlockCount);
    if Result = 0 then
      Result := -SortByName(Item1, Item2);    
  end;
end;

end.
